#include <stdio.h>
#include <string.h>

int total, gene_no, i, j;
char *s1[20], *s2[20], *s3[20], *s4[20], SNP1[20], SNP2[20];
char SNP_name[2000][20];
long SNP_pos[2000], region[1000][2];
double SNP_weight[2000], similarity_ij, similarity_ji; 
float r2;

void main()
{
	FILE *f1, *f2, *f3, *f4;
	f1 = fopen("chr9_raw_processed.txt", "r");
    f2 = fopen("chr9_LD_unweighted.txt", "r");
	f3 = fopen("chr9_gene_processed.txt", "r");
	f4 = fopen("chr9_LD_processed.txt", "w");


	total = 0;
	while ( !feof(f1) )
	{
		fscanf(f1, "%s %ld %s\n", SNP_name[total], &SNP_pos[total], s3);
		total++;
	}

	gene_no = 0;
	while ( !feof(f3) )
	{
		fscanf(f3, "%s %s %s %ld %ld\n", s1, s2, s3, &region[gene_no][0], &region[gene_no][1] );
		gene_no++;
	}

	for ( i = 0; i < total; i++ )
		SNP_weight[i] = 0.4;
	for ( i = 0; i < total; i++ )
	{
		for ( j = 0; j < gene_no; j++)
		{
			if ( SNP_pos[i] >= region[j][0] && SNP_pos[i] <= region[j][1] )
				SNP_weight[i] = 0.8;
		}
	}


	while ( !feof(f2) )
	{
		fscanf(f2, "%s %s %f\n", SNP1, SNP2, &r2);
		
		i = 0; j = 0;
		while ( strcmp(SNP1, SNP_name[i]) != 0 && i < total)
			i++;
		while ( strcmp(SNP2, SNP_name[j]) != 0 && j < total)
			j++;

			similarity_ij = 0.8 - ( SNP_weight[j] - r2 );

			similarity_ji = 0.8 - ( SNP_weight[i] - r2 );

		fprintf(f4, "%s %s %f\n", SNP1, SNP2, similarity_ij);
		fprintf(f4, "%s %s %f\n", SNP2, SNP1, similarity_ji);

	}



/*    if ( strcmp ( SNP_name[total-1], "rs754605" ) == 0 )
		fprintf(f4, "if is okay, %s %ld %s\n", SNP_name[total-1], SNP_pos[total-1], s3);
	fprintf(f4, "%ld %ld\n", region[gene_no-1][0], region[gene_no-1][1]);
	fprintf(f4, "%s %s %f %d %d %d\n", SNP1, SNP2, r2, total, i, j);
	fprintf(f4, "%f %f\n", SNP_weight[1], SNP_weight[total-1]);
*/	

	fclose(f1);
	fclose(f2);
	fclose(f3);
	fclose(f4);

}